#include"nRF24L01.h"


uchar code TX_ADDRESS[TX_ADR_WIDTH] = {0xb1,0xb2,0xb3,0xb4,0x01};//0x34,0x43,0x10,0x10,0x01};  // ·ɽڵַ
uchar code RX_ADDRESS1[TX_ADR_WIDTH] = {0xb0,0xb2,0xb3,0xb4,0x01};//дַĴдֽڣ˺漸ֽͬ
uchar code RX_ADDRESS2[1] = {0xb1};
uchar code RX_ADDRESS3[1] = {0xb2};
uchar code RX_ADDRESS4[1] = {0xb3};
uchar code RX_ADDRESS5[1] = {0xb4};
uchar RX_BUF[TX_PLOAD_WIDTH];
uchar TX_BUF[TX_PLOAD_WIDTH]=
{
0x01,0x02,0x03,0x4,0x05,0x06,0x07,0x08,
0x09,0x10,0x11,0x12,0x13,0x14,0x15,0x16,
0x17,0x18,0x19,0x20,0x21,0x22,0x23,0x24,
0x25,0x26,0x27,0x28,0x29,0x30,0x31,0x32,
};
uchar flag,status;
uchar DATA = 0x01;

uchar bdata sta;
sbit  RX_DR	 = sta^6;
sbit  TX_DS	 = sta^5;
sbit  MAX_RT = sta^4;
/**************************************************/

/**************************************************
: init_io()

:
    ʼIO
/**************************************************/
void init_io(void)
{
	CE  = 0;        // 
	CSN = 1;        // SPIֹ
	SCK = 0;        // SPIʱõ
	IRQ = 1;        // жϸλ
	LED = 0x00;		// رָʾ
}
/**************************************************/

/**************************************************
delay_ms()


    ӳx
/**************************************************/
void delay_ms(uchar x)
{
    uchar i, j;
    i = 0;
    for(i=0; i<x; i++)
    {
       j = 250;
       while(--j);
	   j = 250;
       while(--j);
    }
}
/**************************************************/
/*ʱ
/******************************************************************************************/
void inerDelay_us(unsigned char n)
{
	for(;n>0;n--)
		_nop_();
}
/**************************************************
SPI_RW()


    SPIЭ飬дһֽݵnRF24L01ͬʱnRF24L01
	һֽ
/**************************************************/
uchar SPI_RW(uchar byte)
{
	uchar i;
   	for(i=0; i<8; i++)          // ѭ8
   	{
   		MOSI = (byte & 0x80);   // byteλMOSI
   		byte <<= 1;             // һλλλ
   		SCK = 1;                // SCKnRF24L01MOSI1λݣͬʱMISO1λ
   		byte |= MISO;       	// MISObyteλ
   		SCK = 0;            	// SCKõ
   	}
    return(byte);           	// ضһֽ
}
/**************************************************/

/**************************************************
SPI_RW_Reg()


    дvalueregĴ
/**************************************************/
uchar SPI_RW_Reg(uchar reg, uchar value)
{
	uchar status;
  	CSN = 0;                   // CSNõͣʼ
  	status = SPI_RW(reg);      // ѡĴͬʱ״̬
  	SPI_RW(value);             // ȻдݵüĴ
  	CSN = 1;                   // CSNߣݴ
  	return(status);            // ״̬Ĵ
}
/**************************************************/

/**************************************************
SPI_Read()


    regĴһֽ
/**************************************************/
uchar SPI_Read(uchar reg)
{
	uchar reg_val;
  	CSN = 0;                    // CSNõͣʼ
  	SPI_RW(reg);                // ѡĴ
  	reg_val = SPI_RW(0);        // ȻӸüĴ
  	CSN = 1;                    // CSNߣݴ
  	return(reg_val);            // ؼĴ
}
/**************************************************/

/**************************************************
SPI_Read_Buf()


    regĴbytesֽڣͨȡͨ
	ݻ/͵ַ
/**************************************************/
uchar SPI_Read_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                    // CSNõͣʼ
  	status = SPI_RW(reg);       // ѡĴͬʱ״̬
  	for(i=0; i<bytes; i++)
    	pBuf[i] = SPI_RW(0);    // ֽڴnRF24L01
  	CSN = 1;                    // CSNߣݴ
  	return(status);             // ״̬Ĵ
}
/**************************************************/

/**************************************************
SPI_Write_Buf()


    pBufед뵽nRF24L01ͨд뷢
	ͨݻ/͵ַ
/**************************************************/
uchar SPI_Write_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                    // CSNõͣʼ
  	status = SPI_RW(reg);       // ѡĴͬʱ״̬
  	for(i=0; i<bytes; i++)
    	SPI_RW(pBuf[i]);        // ֽдnRF24L01
  	CSN = 1;                    // CSNߣݴ
  	return(status);             // ״̬Ĵ
}
/**************************************************/

/**************************************************
RX_Mode()


    nRF24L01Ϊģʽȴշ豸ݰ
/**************************************************/
void RX_Mode(void)
{
	CE = 0;
  	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);              // CRCʹܣ16λCRCУ飬ϵ磬ģʽ
  	CE = 1;                                            // CE豸
	inerDelay_us(130);
}
/**************************************************/

/**************************************************
TX_Mode()


    nRF24L01ΪģʽCE=110us
	130us䣬ݷͽ󣬷ģԶת
	ģʽȴӦźš
/**************************************************/
void TX_Mode(uchar * BUF)
{
	CE = 0;
  	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     // д뷢͵ַ
  	SPI_Write_Buf(WR_TX_PLOAD, BUF, TX_PLOAD_WIDTH);                  // дݰTX FIFO
	CE = 1;
	inerDelay_us(10);
}
/**************************************************/

/**************************************************
Check_ACK()


    豸޽յݰ趨ûյӦ
	Ƿط
/**************************************************/
uchar Check_ACK(bit clear)
{
	while(IRQ);
	sta = SPI_RW(NOP);                    // ״̬Ĵ
	if(MAX_RT)
		if(clear)                         // ǷTX FIFOûڸλMAX_RTжϱ־ط
			SPI_RW(FLUSH_TX);
	SPI_RW_Reg(WRITE_REG + STATUS, sta);  // TX_DSMAX_RTжϱ־
	IRQ = 1;
	if(TX_DS)
		return(0x00);
	else
		return(0xff);
}
/**************************************************/

/**************************************************
CheckButtons()


    鰴Ƿ£һֽ
/**************************************************/
void CheckButtons()
{
	uchar i=0;
	if(flag)		           // 
	{
		flag = 0;		       // ־
		R_S_Byte('N');
		R_S_Byte(status);
		for(i=0;i<32;i++)
		   R_S_Byte(RX_BUF[i]);

		LED = 0xff;		       // رLED
	}
}
/**************************************************/
//************************************ڳʼ*********************************************************
void StartUART( void )
{  							//2400
     SCON = 0x50;
     TMOD = 0x20;
     TH1 = 0xF3;
     TL1 = 0xF3;
     PCON = 0x00;
     TR1 = 1;
}
//************************************ͨڽյݷ͸PC**************************************
void R_S_Byte(uchar R_Byte)
{	
	 SBUF = R_Byte;  
    while( TI == 0 );				//ѯ
  	 TI = 0;    
}
/************************************************************/
// Ƭⲿжϣȡյ
/************************************************************/
void exter0() interrupt 0
{
	sta = SPI_Read(STATUS);	  // ״̬Ĵ
   if(RX_DR)				  // жǷܵ
	{
		status=sta;
		status&=0x0e;
		status>>=1;
		SPI_Read_Buf(RD_RX_PLOAD, RX_BUF, TX_PLOAD_WIDTH);  // RX FIFO
		flag = 1;
	}
	SPI_RW_Reg(WRITE_REG + STATUS, sta);  // RX_DSжϱ־	
}
/************************************************************/
// nRF24L01ʼ
/************************************************************/
void Init_24L01()
{
	CE=0;
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);//дͨ0Ľյַ뷢͵ַͬ
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P1, RX_ADDRESS1, TX_ADR_WIDTH); //дͨ1Ľյַ
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P2, RX_ADDRESS2, 1);//дͨ2Ľյַ
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P3, RX_ADDRESS3, 1);//дͨ3Ľյַ
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P4, RX_ADDRESS4, 1);//дͨ4Ľյַ
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P5, RX_ADDRESS5, 1);//дͨ5Ľյַ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  // ͨ0ѡͷͨͬЧݿȣ32ֽڳ
  	SPI_RW_Reg(WRITE_REG + RX_PW_P1, TX_PLOAD_WIDTH);//32ֽڳ
  	SPI_RW_Reg(WRITE_REG + RX_PW_P2, TX_PLOAD_WIDTH);//32ֽڳ
  	SPI_RW_Reg(WRITE_REG + RX_PW_P3, TX_PLOAD_WIDTH);//32ֽڳ
  	SPI_RW_Reg(WRITE_REG + RX_PW_P4, TX_PLOAD_WIDTH);//32ֽڳ
  	SPI_RW_Reg(WRITE_REG + RX_PW_P5, TX_PLOAD_WIDTH);//32ֽڳ
  	SPI_RW_Reg(WRITE_REG + EN_AA, 0x3f);       // ʹнͨԶӦ
  	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x3f);   // ʹнͨ
	SPI_RW_Reg(WRITE_REG + RF_CH, 40);                 // ѡƵͨ0x40
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);            // ݴ1Mbps书0dBmŴ
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);      // CRCʹܣ16λCRCУ飬ϵ
	SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x0a);  // Զطʱȴ250us+86usԶط10
	CE=1;
}
